<template>
  <div v-if="(items.length > 0)">
    <Planning :items="chart" />
  </div>
  <div class="d-flex justify-content-between mb-3">
    <div></div>
    <div></div>
    <div class="row">
      <div class="col-auto">
        <select class="form-select " v-model="selectedSeason" @change="updateSelectedSeason" >
          <option v-for="season in seasons" :key="season" :value="season">
            {{ season }}
          </option>
        </select>
      </div>
      <div class="col-auto">
        <button @click="showModal = true" class="btn btn-light ml-2"> Aujouter une opération<svg class="svg-inline--fa fa-plus fa-w-14" aria-hidden="true" focusable="false" data-prefix="fa" data-icon="plus" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" data-fa-i2svg=""><path fill="currentColor" d="M416 208H272V64c0-17.67-14.33-32-32-32h-32c-17.67 0-32 14.33-32 32v144H32c-17.67 0-32 14.33-32 32v32c0 17.67 14.33 32 32 32h144v144c0 17.67 14.33 32 32 32h32c17.67 0 32-14.33 32-32V304h144c17.67 0 32-14.33 32-32v-32c0-17.67-14.33-32-32-32z"></path></svg><!-- <i class="fa fa-plus"></i> Font Awesome fontawesome.com -->
        </button>
      </div>
    </div>
  </div>
  <Create :show="showModal" @close="showModal = false">
    <template #default>
      <div class="modal-header">
        <h5 class="modal-title">Modal title</h5>
        <button  @click="showModal = false" type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <form @submit.prevent="submit">
        <div class="form-group   row">
            <label class="col-md-4 col-form-label text-md-right">Name</label>
            <div class="col-md-6">
                <input type="text" wire:model.defer="nom" class="form-control input-sm"
                       placeholder="Nom de l'opération">
            </div>

        </div>
         <div class="form-group row">
            <label class="col-md-4 col-form-label text-md-right">
                <label class="col-md-4 col-form-label text-md-right">SHOP</label>
            </label>
            <div class="col-md-6">
                <select wire:model.defer="shop" class="form-control">
                    <option>WILLEMSE</option>
                    <option>BAKKER</option>
                </select>
            </div>
        </div>
        <div class="form-group row">
            <label class="col-md-4 col-form-label text-md-right">Type
                
            </label>
            <div class="col-md-6">
              <select class="form-select " >
                <option v-for="season in seasons" :key="season" :value="season">
                  {{ season }}
                </option>
              </select>
            </div>
        </div>
        <div class="form-group row">
            <label class="col-md-4 col-form-label text-md-right">Date debut</label>
            <div class="col-md-6">
                <input required type="date" class="form-control input-sm" id="date_debut" wire:model.defer="date_debut">
            </div>
        </div>
        <div class="form-group row">
            <label class="col-md-4 col-form-label text-md-right">Date fin</label>
            <div class="col-md-6">
                <input type="date" class="form-control input-sm"  id="date_fin" wire:model.defer="date_fin">
            </div>
        </div>

    </form>
      </div>

    </template>
    <template #footer>
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal" @click="showModal = false">Close</button>
        <button type="button" class="btn btn-primary">Save changes</button>
    </template>
  </Create>
  <EasyDataTable
      buttons-pagination
      :headers="headers"
      :items="items"
      :loading="loading"
      theme-color="#216155"
      table-class-name="customize-table"
  >
    <template #item-type="{type}">
      <span class="badge rounded-pill" v-bind:class="getClasses(type)">{{ type }}  </span>
    </template>
    <template #item-date_debut="{date_debut}" class="text-centr">
      {{ date_debut }}
    </template>
    <template #item-action="{item}" class="text-centr">
      <button class="btn btn-light ml-2"> <svg class="svg-inline--fa fa-plus fa-w-14" aria-hidden="true" focusable="false" data-prefix="fa" data-icon="plus" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" data-fa-i2svg=""><path fill="currentColor" d="M416 208H272V64c0-17.67-14.33-32-32-32h-32c-17.67 0-32 14.33-32 32v144H32c-17.67 0-32 14.33-32 32v32c0 17.67 14.33 32 32 32h144v144c0 17.67 14.33 32 32 32h32c17.67 0 32-14.33 32-32V304h144c17.67 0 32-14.33 32-32v-32c0-17.67-14.33-32-32-32z"></path></svg><!-- <i class="fa fa-plus"></i> Font Awesome fontawesome.com -->
              </button>
    </template>
  </EasyDataTable> 
  
</template>

<script  lang="ts">
import Planning from "./Planning.vue";
import Create from "./Create.vue";
import { defineComponent, ref, onMounted, computed  } from "vue";
import { Header, Item,SortType } from "vue3-easy-data-table";
import { useForm, useField } from 'vee-validate'
import { getOperations } from '../../composition-api/operations.api';

export default defineComponent({
  components: {Planning,Create},
  setup() {
    
    const sortBy: string[] = ["date_debut", "date_fin"];
    const sortType: SortType[] = ["desc", "asc"];
    const headers: Header[] = [
        { text: "Type", value: "type", sortable:true,width:50},  // set fixed to true
        { text: "Nom", value: "nom", sortable:true,width:400},
        { text: "Semaine", value: "semaine",},
        { text: "Date de début", value: "date_debut",sortable:true},
        { text: "Date de fin", value: "date_fin",sortable:true},
        { text: "Nb refs", value: "nb_refs",sortable:true},
        { text: " ", value: "action"}
    ];
    const items: Item[] = ref([]);
    const chart = ref([]);
    const loading = ref(true);

    let showModal = ref(false);

    const startDate = ref(new Date(2020, 0, 1)); // Date de début des saisons
    const currentDate = ref(new Date());
    const currentSeason = computed(() => seasons.value.find(season => season.currentSeason));
    const selectedSeason = ref('')
    const seasons = ref([] as { name: string, start: Date, end: Date, currentSeason: boolean }[]);

    const { form, errors } = useForm()
    const email = useField('email', form, {
      required: true,
      email: true,
    })
    const password = useField('password', form, {
      required: true,
      min: 8,
    })

    interface SeasonType{
        name: string,
        start:Date
        end: any,
        currentSeason:Boolean
    }

    function updateSelectedSeason(event:any) {
      selectedSeason.value = event.target.value;
    }

    function getSeasons(startDate:Date, currentDate:Date) {
      const seasons:Array<SeasonType> = [];
      let currentSeasonStart = startDate;
      let currentSeasonEnd;
      let currentSeasonName;
      
      while (currentSeasonStart <= currentDate) {
        if (currentSeasonStart.getMonth() < 6) {
          currentSeasonEnd = new Date(currentSeasonStart.getFullYear(), 6, 1);
          currentSeasonName = `PE ${currentSeasonStart.getFullYear()}`;
        } else {
          currentSeasonEnd = new Date(currentSeasonStart.getFullYear() + 1, 0, 1);
          currentSeasonName = `AH ${currentSeasonStart.getFullYear()}`;
        }
        const currentSeason = currentSeasonStart <= currentDate && currentDate < currentSeasonEnd;
        seasons.push({
          name: currentSeasonName,
          start: currentSeasonStart,
          end: currentSeasonEnd,
          currentSeason: currentSeason
        });
        currentSeasonStart = currentSeasonEnd;
      }
      if (currentDate.getTime() >= (seasons[seasons.length - 1].end.getTime() - 30 * 24 * 60 * 60 * 1000)) {
        const nextSeasonStart = seasons[seasons.length - 1].end;
        let nextSeasonEnd;
        let nextSeasonName;
        if (nextSeasonStart.getMonth() < 6) {
          nextSeasonEnd = new Date(nextSeasonStart.getFullYear(), 6, 1);
          nextSeasonName = `PE ${nextSeasonStart.getFullYear()}`;
        } else {
          nextSeasonEnd = new Date(nextSeasonStart.getFullYear() + 1, 0, 1);
          nextSeasonName = `AH ${nextSeasonStart.getFullYear()}`;
        }
        seasons.push({
          name: nextSeasonName,
          start: nextSeasonStart,
          end: nextSeasonEnd,
          currentSeason: false
        });
      }
      
    return seasons;
    }

    async function getAllOperations(){
        const [error , data] = await getOperations();
        if (error) console.error(error);
        else {
          items.value = data[0];
          chart.value = data[1];
          loading.value = false;
        };
    }

    const formattedSeasons = computed(() => seasons.value.map(season => season.name));

    onMounted(() => {
      seasons.value = getSeasons(startDate.value, currentDate.value);

      if (currentSeason.value) {
        selectedSeason.value = currentSeason.value.name;
      }
    });
    function getClasses(type:string){
      console.log("getColor")
      switch (type) {
        case 'VF':
          return 'bg-vf';
        case 'HP1':
          return 'bg-hp1';
        case 'HP2':
          return 'bg-hp2';
        case 'HP3':
          return 'bg-hp3';
        case 'BONNE AFFAIRE':
          return 'bg-ba';
        default:
          return 'bg-default';
      }
    }
    function submit() {
      form.validate().then(valid => {
        if (valid) {
          // Soumettez le formulaire ici
          console.log(form.value)
        }
      })
    }
    return {
      showModal,
      getSeasons,
      getAllOperations,
      updateSelectedSeason,
      headers,
      loading,
      items,
      chart,
      startDate,
      currentDate,
      seasons: formattedSeasons,
      selectedSeason,
      getClasses,
      email,
      password,
      errors,
      submit,
      
    };
  },
  async created(){
       await this.getAllOperations()
        
    }
});
</script>
<style>
.customize-table {
  --easy-table-border-radius: 8px;

  --easy-table-header-font-size: 14px;
  --easy-table-header-height: 50px;

  --easy-table-header-border-radius: 8px 8px 0 0;
  --easy-table-header-item-padding: 10px 15px;

  --easy-table-body-even-row-font-color: #fff;
  --easy-table-body-border-radius: 0 0 8px 8px;

  --easy-table-body-row-height: 50px;
  --easy-table-body-row-font-size: 14px;

  --easy-table-body-item-padding: 10px 15px;

  --easy-table-footer-font-size: 14px;
  --easy-table-footer-padding: 0px 10px;
  --easy-table-footer-height: 50px;

  --easy-table-rows-per-page-selector-width: 70px;
  --easy-table-rows-per-page-selector-option-padding: 10px;

}
.bg-vf{
  color: #fff;
  background-color: #19b1f7;
}
.bg-hp1{
  color: #fff;
  background-color: #ccb2d4;
}
.bg-hp2{
  color: #fff;
  background-color: #c83df2;
}
.bg-hp3{
  color: #fff;
  background-color: #78039c;
}
.bg-ba{
  color: #fff;
  background-color: #f03f13;
}
.bg-default{
  color: #fff;
  background-color: #69b145;
}
</style>